import * as tapable from "tapable";
import { RspackOptionsNormalized } from "./config";
import { Source } from "webpack-sources";
export declare type Asset = {
    source: Source;
    name: string;
    info: AssetInfo;
};
export declare type Assets = Record<string, Asset>;
declare type CompilationAssets = Record<string, Source>;
declare type KnownAssetInfo = Object;
declare type AssetInfo = KnownAssetInfo & Record<string, any>;
export declare class Compilation {
    #private;
    hooks: {
        processAssets: tapable.AsyncSeriesHook<Record<string, Source>>;
    };
    fullHash: string;
    hash: string;
    options: RspackOptionsNormalized;
    assets: CompilationAssets;
    assetsInfo: Map<string, Map<string, Set<string>>>;
    constructor(options: RspackOptionsNormalized);
    /**
     * unsafe to call out of processAssets
     * @param filename
     * @param asset
     */
    updateAsset(filename: string, asset: Asset): void;
    /**
     * unsafe to call out of processAssets
     * @param filename
     * @param asset
     */
    emitAsset(filename: string, asset: Asset): void;
    processAssets(value: string, emitAsset: any): Promise<void>;
    createStats(): {};
    getPath(filename: string, data?: Record<string, any>): any;
    getAssetPath(filename: any, data: any): any;
    getAssets(): Readonly<Asset>[];
    seal(): void;
    unseal(): void;
}
export {};
//# sourceMappingURL=compilation.d.ts.map