"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _Compilation_emitAssetCallback;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Compilation = void 0;
const tapable = __importStar(require("tapable"));
const webpack_sources_1 = require("webpack-sources");
const createHash_1 = require("./utils/createHash");
const hashDigestLength = 8;
const EMPTY_ASSET_INFO = Object.freeze({});
class Compilation {
    constructor(options) {
        _Compilation_emitAssetCallback.set(this, void 0);
        this.hooks = {
            processAssets: new tapable.AsyncSeriesHook([
                "assets"
            ])
        };
        this.options = options;
        const hash = (0, createHash_1.createHash)(this.options.output.hashFunction);
        this.fullHash = hash.digest(options.output.hashDigest);
        this.hash = this.fullHash.slice(0, hashDigestLength);
        this.assets = {};
        this.assetsInfo = new Map();
    }
    /**
     * unsafe to call out of processAssets
     * @param filename
     * @param asset
     */
    updateAsset(filename, asset) {
        this.emitAsset(filename, asset);
    }
    /**
     * unsafe to call out of processAssets
     * @param filename
     * @param asset
     */
    emitAsset(filename, asset) {
        if (!__classPrivateFieldGet(this, _Compilation_emitAssetCallback, "f")) {
            throw new Error("can't call emitAsset out of processAssets hook for now");
        }
        __classPrivateFieldGet(this, _Compilation_emitAssetCallback, "f").call(this, {
            filename: filename,
            asset
        });
    }
    async processAssets(value, emitAsset) {
        var _a;
        __classPrivateFieldSet(this, _Compilation_emitAssetCallback, emitAsset, "f");
        let content = (_a = JSON.parse(value)) !== null && _a !== void 0 ? _a : {};
        let assets = {};
        for (const [key, value] of Object.entries(content)) {
            let buffer = Buffer.from(value);
            // webpack-sources's type definition is wrong, it actually could accept Buffer type
            assets[key] = new webpack_sources_1.RawSource(buffer);
        }
        await this.hooks.processAssets.promise(assets);
    }
    createStats() {
        return {};
    }
    getPath(filename, data = {}) {
        if (!data.hash) {
            data = {
                hash: this.hash,
                ...data
            };
        }
        return this.getAssetPath(filename, data);
    }
    getAssetPath(filename, data) {
        return filename;
    }
    getAssets() {
        const array = [];
        for (const assetName of Object.keys(this.assets)) {
            array.push({
                name: assetName,
                source: this.assets[assetName],
                info: this.assetsInfo.get(assetName) || EMPTY_ASSET_INFO
            });
        }
        return array;
    }
    seal() { }
    unseal() { }
}
exports.Compilation = Compilation;
_Compilation_emitAssetCallback = new WeakMap();
//# sourceMappingURL=compilation.js.map