"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDevOptions = exports.getAdditionDevEntry = void 0;
const node_path_1 = __importDefault(require("node:path"));
const watch_1 = require("./watch");
function getAdditionDevEntry() {
    const devClientEntryPath = require.resolve("@rspack/dev-client");
    const additionalEntry = {
        "rspack-dev-client": [devClientEntryPath],
        "rspack-hot-update": [require.resolve("@rspack/dev-client/devServer")]
    };
    return additionalEntry;
}
exports.getAdditionDevEntry = getAdditionDevEntry;
function resolveDevOptions(devConfig = {}, context) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const port = (_a = devConfig.port) !== null && _a !== void 0 ? _a : 8080;
    const open = true;
    const hot = (_b = devConfig.hot) !== null && _b !== void 0 ? _b : false;
    // --- static
    const directory = (_d = (_c = devConfig.static) === null || _c === void 0 ? void 0 : _c.directory) !== null && _d !== void 0 ? _d : node_path_1.default.resolve(context.context, "dist");
    let watch = {};
    if (((_e = devConfig.static) === null || _e === void 0 ? void 0 : _e.watch) === false) {
        watch = false;
    }
    else if (((_f = devConfig.static) === null || _f === void 0 ? void 0 : _f.watch) === true) {
        watch = (0, watch_1.resolveWatchOption)({});
    }
    else if ((_g = devConfig.static) === null || _g === void 0 ? void 0 : _g.watch) {
        watch = (_h = devConfig.static) === null || _h === void 0 ? void 0 : _h.watch;
    }
    // ---
    const devMiddleware = (_j = devConfig.devMiddleware) !== null && _j !== void 0 ? _j : {};
    const liveReload = (_k = devConfig.liveReload) !== null && _k !== void 0 ? _k : true;
    let webSocketServer = {};
    if (devConfig.webSocketServer === false) {
        webSocketServer = false;
    }
    else if (devConfig.webSocketServer === true) {
        webSocketServer = {};
    }
    else if (devConfig.webSocketServer) {
        webSocketServer = devConfig.webSocketServer;
    }
    return {
        port,
        static: {
            directory,
            watch
        },
        devMiddleware,
        open,
        hot,
        liveReload,
        webSocketServer
    };
}
exports.resolveDevOptions = resolveDevOptions;
//# sourceMappingURL=devServer.js.map