"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveEntryOptions = void 0;
const devServer_1 = require("./devServer");
const path_1 = __importDefault(require("path"));
function resolveEntryOptions(options, context) {
    const additionDevEntry = context.dev ? (0, devServer_1.getAdditionDevEntry)() : {};
    if (typeof options === "undefined" || options === null) {
        return {
            main: [path_1.default.resolve(context.context, "src", "index.js")],
            ...additionDevEntry
        };
    }
    else if (typeof options === "string") {
        return {
            main: [options],
            ...additionDevEntry
        };
    }
    else if (Array.isArray(options)) {
        return {
            main: options,
            ...additionDevEntry
        };
    }
    else if (typeof options === "object") {
        return Object.fromEntries(Object.entries({ ...options, ...additionDevEntry }).map(([key, value]) => {
            if (Array.isArray(value)) {
                return [key, value];
            }
            else {
                return [key, [value]];
            }
        }));
    }
    else {
        return {};
    }
}
exports.resolveEntryOptions = resolveEntryOptions;
// export function resolveEntryOptions(
// 	entry: Record<string, string> | string,
// 	options: { context: string; dev: boolean }
// ) {
// 	if (typeof entry === "string") {
// 		entry = {
// 			main: entry
// 		};
// 	}
// 	return {
// 		...mapValues(entry, item => path.resolve(options.context, item)),
// 		...(options.dev ? getAdditionDevEntry() : {})
// 	};
// }
//# sourceMappingURL=entry.js.map